#include <sys/socket.h>
#include <features.h>    /* for the glibc version number */
#if __GLIBC__ >= 2 && __GLIBC_MINOR >= 1
#include <netpacket/packet.h>
#include <net/ethernet.h>     /* the L2 protocols */      
#else
#include <asm/types.h>
#include <linux/if_packet.h>
#include <linux/if_ether.h>   /* The L2 protocols */       
#endif

#define ETH_SIZE 1500
struct sockaddr_ll from;
int main()
{
int i;
int s0;
int len;
int from_len;
unsigned char buffer[ETH_SIZE]; 
s0=socket(PF_PACKET, SOCK_DGRAM, htons(ETH_P_ALL) );
if (s0 == -1 ){
	perror("socket fallita");
	return 1;
}
while(from.sll_protocol!=0x0608 /*htons(0x0806)*/){
from.sll_family = AF_PACKET;
from.sll_protocol = htons(ETH_P_ALL);
from.sll_ifindex =0;
from.sll_pkttype = 0;
from.sll_hatype=0;
from.sll_halen=0;
from_len = sizeof(struct sockaddr_ll);
len = recvfrom(s0,buffer,ETH_SIZE,0,(struct sockaddr*)&from,&from_len);
if ( len == -1 ){
	perror("recvfrom fallita");
	return 1;
	}
}
for(i=0;i<len;i++){
	printf("%x ",buffer[i]);
	}
printf("\n");
return 0;
}	
